#include "confirm-dialog.h"

ConfirmDialog::ConfirmDialog()
    : c_Label1("_First name", true),
      c_ButtonBox(Gtk::Orientation::HORIZONTAL, 5), c_Button_OK("_OK", true),
      c_Button_Cancel("_Cancel", true) {
  set_destroy_with_parent(true);

  set_title("Name Dialog");
  set_child(c_Grid);

  c_Grid.set_row_spacing(4);
  c_Grid.set_column_spacing(4);
  c_Grid.set_expand(true);

  c_Image.set_from_icon_name("dialog-question");
  c_Image.set_icon_size(Gtk::IconSize::LARGE);
  c_Grid.attach(c_Image, 0, 0, 1, 2);

  c_Grid.attach(c_Label1, 1, 0);
  c_Grid.attach(c_Entry1, 2, 0);
  c_Label1.set_mnemonic_widget(c_Entry1);

  c_Grid.attach(c_ButtonBox, 0, 2, 3, 1);
  c_ButtonBox.set_halign(Gtk::Align::END);
  c_ButtonBox.append(c_Button_OK);
  c_ButtonBox.append(c_Button_Cancel);
}

void ConfirmDialog::buttons_clicked_connect(
    const sigc::slot<void(const Glib::ustring &)> &slot) {
  c_Button_OK.signal_clicked().connect(sigc::bind(slot, "OK"));
  c_Button_Cancel.signal_clicked().connect(sigc::bind(slot, "Cancel"));
}

Glib::ustring ConfirmDialog::get_entry1() const { return c_Entry1.get_text(); }

ConfirmDialog::~ConfirmDialog() {}
