#include "main-window.h"
#include "color.h"
#include "glibmm/ustring.h"
#include "gtkmm/image.h"
#include "ultra-mega-functions.h"
#include <bits/stdc++.h>
#include <cstddef>
#include <cstdint>
#include <glib/gi18n.h>
#include <iostream>
#include <ostream>
#include <string>
#include <unistd.h>
#include <vector>

MainWindow::MainWindow()
    : m_button_spin("spin"), m_button_reset("reset money"),
      m_button_quit("Quit"), slot_image0(), slot_image1(), slot_image2(),
      m_label_money(), m_label_spins(), m_label_info(), m_entry_bet(),
      m_timer_number(0) {
  set_title("Pupes Slots!");

  m_grid_quit.set_margin(12);
  set_child(m_grid_quit);

  can_spin = true;

  money = 100;
  spins = 0;

  // bet entry
  m_entry_bet.set_icon_from_icon_name("input-gaming");
  m_entry_bet.set_placeholder_text("enter you bet");

  // spins and money
  m_label_spins.set_label("spins: " + std::to_string(spins));
  m_label_spins.set_justify(Gtk::Justification::LEFT);
  m_label_money.set_label("money: " + std::to_string(money));
  m_label_money.set_justify(Gtk::Justification::LEFT);

  // set image size
  slot_image0.set_size_request(128, 128);
  slot_image1.set_size_request(128, 128);
  slot_image2.set_size_request(128, 128);

  // status rows
  m_grid_main.attach(m_label_spins, 0, 0);
  m_grid_main.attach(m_label_money, 0, 1);

  // row 2: slots
  m_grid_main.attach(slot_image0, 0, 2);
  m_grid_main.attach(slot_image1, 1, 2);
  m_grid_main.attach(slot_image2, 2, 2);

  // info label
  m_grid_main.attach(m_label_info, 1, 3);

  // row 4 spin button, bet entry, reset button
  m_grid_main.attach(m_button_spin, 0, 4);
  m_grid_main.attach(m_entry_bet, 1, 4);
  m_grid_main.attach(m_button_reset, 2, 4);

  // attach main grid to to level quit grid and add quit button
  m_grid_quit.attach(m_grid_main, 0, 0);
  m_grid_quit.attach(m_button_quit, 0, 1);

  m_button_spin.signal_clicked().connect(
      sigc::bind(sigc::mem_fun(*this, &MainWindow::on_button_spin)));

  m_button_quit.signal_clicked().connect(
      sigc::mem_fun(*this, &MainWindow::on_button_quit));
}

MainWindow::~MainWindow() {}

void MainWindow::on_button_quit() { set_visible(false); }

// define symbols for slots
const Glib::ustring symbol[8]{
    IMG_FOLDER "/Arch.svg",      IMG_FOLDER "/Debian.svg",
    IMG_FOLDER "/Slackware.svg",

    IMG_FOLDER "/Beastie.svg",   IMG_FOLDER "/DragonFly.svg",
    IMG_FOLDER "/Puffy.svg",

    IMG_FOLDER "/GNU.svg",       IMG_FOLDER "/Tux.svg"};

void MainWindow::randomise_slots(bool save, Glib::ustring *slot_status) {
  uint8_t randoms[3];

  for (int i = 0; i < (sizeof(randoms) / sizeof(*randoms)); i++) {
    randoms[i] = get_random_num(0, ((sizeof(symbol) / sizeof(*symbol)) - 1));
  }
  slot_image0.set(symbol[randoms[0]]);
  slot_image1.set(symbol[randoms[1]]);
  slot_image2.set(symbol[randoms[2]]);

  if (save) {
    for (int i = 0; i < (sizeof(randoms) / sizeof(*randoms)); i++) {
      slot_status[i] = symbol[randoms[i]];
    }
  }
}

bool MainWindow::slots_spining(int timer_number, unsigned long long bet) {

  std::cout << "This is timer " << timer_number;

  // decrement and check counter value
  if (--m_counters[timer_number] == 0) {
    std::cout << " being disconnected" << std::endl;

    // delete the counter entry in the STL MAP
    m_counters.erase(timer_number);

    // delete the connection entry in the STL MAP
    m_timers.erase(timer_number);

    Glib::ustring slot_status[3];
    randomise_slots(true, slot_status);

    // debug statement
    for (int i = 0; i < (sizeof(slot_status) / sizeof(*slot_status)); i++) {
      std::cout << "slot: " << i << " is " << slot_status[i] << std::endl;
    }

    // check if win
    {
      if ((slot_status[0].compare(slot_status[1])) == 0 &&
          slot_status[0].compare(slot_status[2]) == 0) {
        money += (bet * 2);
        m_label_money.set_label("money: " + std::to_string(money));
        spawn_alert("Jackpot!",
                    "All symbols are the same your bet doubled.\nDon't stop!");
        goto end_win_check;
      } else {
        {
          // vector goes brr
          std::vector<uint8_t> combo;
          std::vector<bool> win_main(
              (sizeof(slot_status) / sizeof(*slot_status)), false);

          for (uint8_t i = 0; i < 2; i++) {
            if (i == 0) {
              combo = {0, 1, 2};
            } else if (i == 1) {
              combo = {3, 4, 5};
            } else {
              std::cerr << RED
                  "Critical ERROR:\nindex out of bounds detected\n app "
                  "will terminate in few seconds\n" RESET;
              spawn_alert("Critical ERROR",
                          "index out of bounds detected\n app "
                          "will terminate in few seconds");
              sleep(5);
              exit(15);
            }

            // WARNING you are about to enter "for loop hell"
            // proceed with caution

            for (int j = 0; j < (sizeof(slot_status) / sizeof(*slot_status));
                 j++) {
              bool wining_ok = false;

              for (int k = 0; k < (combo.size()); k++) {
                if ((slot_status[j].compare(symbol[combo[k]])) == 0) {
                  wining_ok = true;
                }
              }
              if (wining_ok) {
                win_main[j] = true;
              }
            }
            for (int j = 0; j < (win_main.size()); j++) {
              if (!win_main[j]) {
                win_main.assign(win_main.size(), false);
                break;
              }
              if (j == ((win_main.size()) - 1)) {
                money += (bet * 1.5);
                m_label_money.set_label("money: " + std::to_string(money));
                if (i == 0) {
                  spawn_alert(
                      "Distro combo!",
                      "your bet multiplied by factor of 1.5.\n Don't stop!");
                } else if (i == 1) {
                  spawn_alert(
                      "BSD combo!",
                      "your bet multiplied by factor of 1.5.\n Don't stop!");
                }
                // "goto" mentioned
                goto end_win_check;
              }
            }
          }
        }
        // this code gets executed only if you lose,
        // otherwise it jumps to goto label
        spawn_alert("You Lose", "Your bet was lost. :(\nbut don't stop");
      }
    }
    // goto label!!!
  end_win_check:

    can_spin = true;
    // return false, to stop timer
    return false;
  } else {
    if (m_counters[timer_number] < (count_value * 0.4)) {
      if (get_random_num(0, 1) == 1) {
        randomise_slots(false, NULL);
      }
    } else if (m_counters[timer_number] < (count_value * 0.2)) {
      if (get_random_num(0, 4) == 1) {
        randomise_slots(false, NULL);
      }
    } else {
      randomise_slots(false, NULL);
    }
  }
  // Print the timer value
  std::cout << " - " << m_counters[timer_number] << "/" << count_value
            << std::endl;

  // Keep going (do not disconnect yet):
  return true;
}

void MainWindow::on_button_spin() {
  if (can_spin) {

    unsigned long long bet;
    try {
      bet = std::stoull(m_entry_bet.get_text());
    } catch (...) {
      spawn_alert("invalid bet", "your bet is either:\n● not a number\n● too "
                                 "high for program to handle");
      return;
    }
    if (bet > money) {
      spawn_alert("Not enough money!",
                  "You placed bet higher than you curent balance");
      return;
    }
    can_spin = false;
    spins++;
    m_label_spins.set_label("spins: " + std::to_string(spins));

    money -= bet;
    m_label_money.set_label("money: " + std::to_string(money));

    count_value = get_random_num(10, 25);
    // Creation of a new object prevents long lines and shows us a little
    // how slots work.  We have 0 parameters and bool as a return value
    // after calling sigc::bind.
    sigc::slot<bool()> my_slot = sigc::bind(
        sigc::mem_fun(*this, &MainWindow::slots_spining), m_timer_number, bet);

    // This is where we connect the slot to the Glib::signal_timeout()
    auto conn = Glib::signal_timeout().connect(my_slot, 300);

    // Remember the connection:
    m_timers[m_timer_number] = conn;

    // Initialize timer count:
    m_counters[m_timer_number] = count_value + 1;

    // Print some info to the console for the user:
    std::cout << "added timeout " << m_timer_number++ << std::endl;
  } else {
    spawn_alert("you are already spining!", "");
  }
}

void MainWindow::spawn_alert(Glib::ustring message, Glib::ustring submessage) {
  m_info_dialog = Gtk::AlertDialog::create();
  if (!m_info_dialog)
    m_info_dialog = Gtk::AlertDialog::create();
  else {
    // Reset values that may have been set by on_button_question_clicked().
    m_info_dialog->set_buttons({});
    m_info_dialog->set_default_button(-1);
    m_info_dialog->set_cancel_button(-1);
  }

  m_info_dialog->set_message(message);
  m_info_dialog->set_detail(submessage);
  m_info_dialog->show(*this);
}
