#ifndef GTKMM_EXAMPLEWINDOW_H
#define GTKMM_EXAMPLEWINDOW_H

#include "confirm-dialog.h"
#include "glibmm/ustring.h"
#include "gtkmm/image.h"
#include "gtkmm/label.h"
#include <gtkmm.h>
#include <locale>
#define IMG_FOLDER "img"

class MainWindow : public Gtk::Window {
public:
  MainWindow();
  virtual ~MainWindow();

private:
  // Signal handlers and functions:
  void on_button_quit();
  void on_button_spin();
  bool slots_spining(int timer_number, unsigned long long bet);
  void randomise_slots(bool save, Glib::ustring *slot_status);
  void spawn_alert(Glib::ustring message, Glib::ustring submessage);

  // Child widgets:
  Gtk::Grid m_grid_quit, m_grid_main;
  Gtk::Label m_label_money, m_label_spins, m_label_info;
  Gtk::Image slot_image0, slot_image1, slot_image2;
  Gtk::Button m_button_spin, m_button_reset, m_button_quit;
  Gtk::Entry m_entry_bet;

  // money and spin counters that can contain even most dihard gamblers
  unsigned long long spins;
  unsigned long long money;

  // counter boobalob
  int m_timer_number;

  // These two constants are initialized in the constructor's member
  // initializer:
  int count_value;

  bool can_spin;
  // STL map for storing our connections
  std::map<int, sigc::connection> m_timers;

  // STL map for storing our timer values.
  // Each timer counts back from COUNT_VALUE to 0 and is removed when it reaches
  // 0
  std::map<int, int> m_counters;

  // add alert dialog
  Glib::RefPtr<Gtk::AlertDialog> m_info_dialog;
};

#endif /* GTKMM_EXAMPLEWINDOW_H */